"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScrollViewIndicator = exports.FlatListIndicator = void 0;
var React = _interopRequireWildcard(require("react"));
var _ScrollIndicator = require("./ScrollIndicator");
var _functions = require("./functions");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
/* eslint-disable react-native/no-inline-styles */
/**
 * @format
 */

const ScrollViewIndicator = props => {
  const {
    position = '',
    horizontal = false,
    persistentScrollbar = false,
    indStyle: {
      width = 5,
      ...indStyle
    } = {},
    containerStyle = {},
    scrollViewProps = {}
  } = props;
  return /*#__PURE__*/React.createElement(_ScrollIndicator.ScrollIndicator, {
    target: "ScrollView",
    targetProps: scrollViewProps,
    horizontal: horizontal,
    position: (0, _functions.getDefaultPosition)(horizontal, position),
    persistentScrollbar: persistentScrollbar,
    indStyle: {
      backgroundColor: 'grey',
      width,
      borderRadius: width / 2,
      ...indStyle
    },
    containerStyle: containerStyle
  }, props.children);
};
exports.ScrollViewIndicator = ScrollViewIndicator;
const FlatListIndicator = props => {
  const {
    flatListProps,
    position = '',
    horizontal = false,
    persistentScrollbar = false,
    indStyle: {
      width = 5,
      ...indStyle
    } = {},
    containerStyle = {}
  } = props;
  return /*#__PURE__*/React.createElement(_ScrollIndicator.ScrollIndicator, {
    target: "FlatList",
    targetProps: flatListProps,
    horizontal: horizontal,
    position: (0, _functions.getDefaultPosition)(horizontal, position),
    persistentScrollbar: persistentScrollbar,
    indStyle: {
      backgroundColor: 'grey',
      width,
      borderRadius: width / 2,
      ...indStyle
    },
    containerStyle: containerStyle
  });
};
exports.FlatListIndicator = FlatListIndicator;
//# sourceMappingURL=index.js.map